﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using Telerik.Windows.Controls;

namespace ListBoxWPF
{
    public class ViewModel: ViewModelBase
    {        
        private string checkedItemsString;
        
        public ViewModel()
        {
            this.ItemsSource = new ObservableCollection<CheckBoxItem>
            {
                new CheckBoxItem { IsChecked=true, Name="Item 1"},
                new CheckBoxItem { IsChecked=false, Name="Item 2"},
                new CheckBoxItem { IsChecked=true, Name="Item 3"},
                new CheckBoxItem { IsChecked=false, Name="Item 4"},
                new CheckBoxItem { IsChecked=true, Name="Item 5"},
                new CheckBoxItem { IsChecked=false, Name="Item 6"},
            };

            this.GetCheckedItemsCommand = new DelegateCommand(OnGetCheckedItemsCommandExecute);
        }

        private void OnGetCheckedItemsCommandExecute(object obj)
        {
            var sb = new StringBuilder();
            var checkedItems = this.ItemsSource.Where(i => i.IsChecked);
            foreach (CheckBoxItem item in checkedItems)
            {
                sb.AppendLine(item.Name);
            }

            this.CheckedItemsString = sb.ToString();
        }

        public ObservableCollection<CheckBoxItem> ItemsSource { get; set; }
        public ICommand GetCheckedItemsCommand { get; set; }

        public string CheckedItemsString
        {
            get
            {
                return this.checkedItemsString;
            }

            set
            {
                if (this.checkedItemsString != value)
                {
                    this.checkedItemsString = value;
                    this.OnPropertyChanged(() => this.CheckedItemsString);
                }
            }
        }
    }
}
